var dataencoder = cgi.transfer("get.cgi?random=" + Math.random(), "get", {
	'key': 'encoder_param'
});
var version=cgi.getItem('version')
var vm = new Vue({
	el: "#app",
	data: {
		isIe9:cgi.isBrowerIE(),
		lang:ch,
		tab:ch.array_vi,//['编码参数','图像参数','曝光参数','OSD参数'],
		index:'0',
		osd_param: {
			osd_video_pos:"",
			osd_video_fontsize:"",
			osd_video_time:	"",
			osd_video_enable:	"",
			osd_video_custominfo:	"",
		},
		encoder_param: dataencoder.encoder_param,
		image_param: {},
		exposure_param: {},
		isIE: cgi.isBrowerIE(),
		showMaxRatio:true,//分辨率隐藏960和1080p
		showencoder:true,//是否显示编码方式
		disEncode:false,//编码方式是否可编辑
		showmjpeg:true,
		show265:false,
		begintime:'00:00',
		endtime:"00:00",
		showIsp:false,//是否显示ISP
		showflip:false,//是否显示吊装
		IspSceneCfg:{
				"sceneMode":"NormalMode",				//当前选择的模式， "NormalMode" 正常地面出入口, "BasementMode" 地库出入口, "BackLightMode" 常规顺逆光, "ExtremeMode" 极端顺光
				"NormalMode": {
					"WDREnable": false,					//是否开启WDR， true or false
					"AutoRegulation": false,			//是否自动调节， true or false
					"ManualLevel": 3					//手动调节时档位， 1-5
				},
				"BasementMode": {
					"WDREnable": false,					//是否开启WDR， true or false
					"AutoRegulation": false,			//是否自动调节， true or false
					"ManualLevel": 3					//手动调节时档位， 1-5
				},
				"BackLightMode": {
					"ExposureRegulationEnable": false	//是否开启曝光自调节， true or false
				},
				"ExtremeMode": {
					"WDREnable": false,					//是否开启WDR， true or false
					"AutoRegulation": false,			//是否自动调节， true or false
					"ManualLevel": 3,					//手动调节时档位， 1-5
					"ValidBeginMinute": 600,			//极端顺光有效的开始时间（单位分钟），比如600代表10：00开始启用
					"ValidIntervalMinute": 60			//极端顺光有效的持续时间（单位分钟），比如60代表1小时，结合上一时间段，代表有效时间为10：00 - 11：00
				}
		},
	},

	methods: {
		//菜单切换
		trigleTab: function(i) {
			this.index = i;
				var that =this;
			switch(i) {
				case 0:
					that.initEncoder();
					break;
				case 1:
					that.initImage();
					break;
				case 2:
					that.initExposure();
					break;
				case 3:
					that.initOSD();
					break;
				case 4:
					that.initIsp();
					break;	
				default:
					break;
			}
		},
		//初始化osd数据
		initOSD: function() {
			var data = cgi.transfer("get.cgi?random=" + Math.random(), "get", {
				'key': 'osd_param'
			});
			this.osd_param.osd_video_pos=data.osd_param.osd_video_pos
			this.osd_param.osd_video_fontsize=data.osd_param.osd_video_fontsize
			this.osd_param.osd_video_time=data.osd_param.osd_video_time
			this.osd_param.osd_video_enable=data.osd_param.osd_video_enable
			this.osd_param.osd_video_custominfo=data.osd_param.osd_video_custominfo
			osd_video_custominfo_previse=data.osd_param.osd_video_custominfo;
			$("[name='osd_video_custominfo']").val(data.osd_param.osd_video_custominfo);
		},
		//初始化编码数据
		initEncoder: function() {
			var that =this;
			if(dataencoder.encoder_param.encoder_maxstream){
				that.encoder_param.encoder_videoquality = '0';
			}else{
				that.encoder_param.encoder_maxstream = '512';
			}
			
			var data = cgi.transfer("get.cgi?random=" + Math.random(), "get", {
				'key': 'encoder_param'
			});
			this.encoder_param = data.encoder_param;
			if(data.encoder_param.encoder_maxstream){
				this.encoder_param.encoder_videoquality = '0';
			}else{
				this.encoder_param.encoder_maxstream = '512';
			}
		},
		//初始化图片数据
		initImage: function() {
			var that = this;
			cgi.httpAjax('get.cgi?random=' + Math.random(), 'get', {
				'key': 'image_param'
			}, function(data) {
				that.image_param = data.image_param;
				//重绘
				setTimeout(function() {
					$("#ex1").slider("value", that.image_param.image_luminance);
					$("#ext2").slider("value", that.image_param.image_contrast);
					$("#ex3").slider("value", that.image_param.image_hue);
					$("#ex4").slider("value", that.image_param.image_saturation);
				}, 500)
			})

		},
		//初始化曝光数据
		initExposure: function() {
			var data = cgi.transfer("get.cgi?random=" + Math.random(), "get", {
				'key': 'exposure_param'
			});
			this.exposure_param = data.exposure_param;
		},
		//初始化ISP
		initIsp: function() {
			var data = cgi.transfer("get.cgi?random=" + Math.random(), "get", {
				'key': 'IspSceneCfg'
			});
			if(JSON.stringify(data) != '{}'){
				this.IspSceneCfg = data.IspSceneCfg;
				//设置时间
			}
			this.setTimes();
		},
		setTimes:function(){
			var ValidBeginMinute = this.IspSceneCfg.ExtremeMode.ValidBeginMinute;
			var ValidIntervalMinute = this.IspSceneCfg.ExtremeMode.ValidIntervalMinute;
			this.begintime = formatSeconds(ValidBeginMinute);
			this.endtime = formatSeconds(ValidBeginMinute+ValidIntervalMinute);
		},
		//提交编码数据
		updataEncoder: function() {
			var that = this;
			that.encoder_param.key = 'encoder_param';
			/*if(!cgi.isPass('.check_ip')) {
				return;
			}*/
			cgi.httpAjax('set.cgi', 'post', that.encoder_param, function(data) {
				if(data == 0) {
					cgi.show_error(note.msg_sussecd,true);
					refreshImageFast('canvasimg')
				} else {
					cgi.show_error(note.msg_error);
				}
			})
		},
		//提交OSD数据
		updataOSD: function() {
			var that = this;
			
			var str = $("[name='osd_video_custominfo']").val();
			var info = str.split("\n");
			var error = 0;
			if(info.length > 4) {
				error = 1;
				cgi.show_error(note.maxRow);
			}
			for(i = 0; i < info.length; i++) {
				if(info[i]) {
					if(info[i].gblen() > 30) {
						cgi.show_error(note.maxLine);
						error = 1
					}
				}
			}
			//繁体版本 osd只支持英文数字.,/
	 		if(version=="ECV85-V3011C-TW"||version=="ECV85-V3011C-MO"||version=="ECV85-V3011C-SG"||version=="ECV85-V3011C-TH"||version=="ECV85-V3011C-ID"||version=="ECV87-V1011C-ABROAD" ||version == 'ECV87-V1011C-ID'||version == 'ECV87-V1011C-CA'|| version == 'ECV87-V1011C-CNKZ'|| version == 'ECV87-V1011C-UZ'|| version == 'ECV87-V1001C-HK'|| version == 'ECV87-V1001C-MO'|| version == 'ECV87-V1021C-MO'|| version == 'ECF88-V2001C-MO' || version=='ECF88-V2001C-HK' ||version == 'ECF88-V2001C'|| version == 'ECV87-V1011C-CHM'|| version=='ECV87-V2001C-MO'|| version=='ECV87-V2001C-TW'|| version=='ECV87-V2001C-TH'|| version=='ECV87-V2001C-CHM'){
	 			var re =  /^[0-9a-zA-Z\s,.\/]*$/;
	 			if(!re.test($("[name='osd_video_custominfo']").val())){
            		cgi.show_error(note.onleEn);
                    return
            	}
	 		}
			
			
			if(error == 1) {
				$("[name='osd_video_custominfo']").val(osd_video_custominfo_previse)
				osd_video_custominfo_previse = $("[name='osd_video_custominfo']").val();
				return;
			}
	
			
			that.osd_param.osd_video_custominfo = $("[name='osd_video_custominfo']").val();
			that.osd_param.key = 'osd_param';
			if(!cgi.isPass('.check_osd')) {
				return;
			}
			cgi.httpAjax('set.cgi', 'post', that.osd_param, function(data) {
				if(data == 0) {
					cgi.show_error(note.msg_sussecd,true);
					refreshImageFast('canvasimg')
				} else {
					cgi.show_error(note.msg_error);
				}
			})
		},
		//提交图片数据
		updataImage: function() {
			var that = this;
			that.image_param.key = 'image_param';
			if(!cgi.isPass('.check_image')) {
				return;
			}
			cgi.httpAjax('set.cgi', 'post', that.image_param, function(data) {
				if(data == 0) {
					cgi.show_error(note.msg_sussecd,true);
					refreshImageFast('canvasimg')
				} else {
					cgi.show_error(note.msg_error);
				}
			})
		},
		//提交曝光数据
		updataExposure: function() {
			var that = this;
			that.exposure_param.key = 'exposure_param';
			if(!cgi.isPass('.check_exposure')) {
				return;
			}
			if(that.exposure_param.exposure_mindgain<=0||that.exposure_param.exposure_mindgain>4){
				cgi.show_error(note.perminnum);//'最小数字增益范围是[0,4]'
				$("[name='exposure_mindgain']").addClass("redInput")
				return;
			}
			if(that.exposure_param.exposure_maxdgain<=0||that.exposure_param.exposure_maxdgain>4){
				cgi.show_error(note.permaxnum);//'最最大数字增益范围是[0,4]'
				$("[name='exposure_maxdgain']").addClass("redInput")
				return;
			}
			
			if(that.exposure_param.exposure_minagain<=0||that.exposure_param.exposure_minagain>16){
				cgi.show_error(note.perminmoni);//'最小模拟增益范围是[0,16]'
				$("[name='exposure_minagain']").addClass("redInput")
				return;
			}
			if(that.exposure_param.exposure_maxagain<=0||that.exposure_param.exposure_maxagain>16){
				cgi.show_error(note.permaxmoni);//'最大模拟增益范围是[0,16]'
				$("[name='exposure_maxagain']").addClass("redInput")
				return;
			}
			
			if(that.exposure_param.exposure_mintime<0||that.exposure_param.exposure_mintime>40000){
				cgi.show_error(note.perminbaog);//'最小曝光时间范围是[0,40000]'
				$("[name='exposure_mintime']").addClass("redInput")
				return;
			}
			if(that.exposure_param.exposure_maxtime<0||that.exposure_param.exposure_maxtime>40000){
				cgi.show_error(note.permaxbaog);
				$("[name='exposure_maxtime']").addClass("redInput")
				return;
			}
			if(parseInt(that.exposure_param.exposure_mintime)>parseInt(that.exposure_param.exposure_maxtime)){
				cgi.show_error(note.infoOfTime);
				return;
			}
			if(parseInt(that.exposure_param.exposure_minagain)>parseInt(that.exposure_param.exposure_maxagain)){
				cgi.show_error(note.infoOfAgain);
				return;
			}
			if(parseInt(that.exposure_param.exposure_mindgain)>parseInt(that.exposure_param.exposure_maxdgain)){
				cgi.show_error(note.infoOfDgain);
				return;
			}
			cgi.httpAjax('set.cgi', 'post', that.exposure_param, function(data) {
				if(data == 0) {
					cgi.show_error(note.msg_sussecd,true);
					refreshImageFast('canvasimg')
					cgi.updataAxvdc();
				} else {
					cgi.show_error(note.msg_error);
				}
			})
		},
		//提交ISP数据
		updataIsp: function() {
			var that = this;
			//that.IspSceneCfg.key = 'IspSceneCfg';
			if(!cgi.isPass('.check_isp')) {
				return;
			}
			var startarr = this.begintime.split(':');
			var endarr = this.endtime.split(':');
			var starsec = (startarr[0]*60-0) + (startarr[1] -0)
			var endsec = (endarr[0]*60-0 )+ (endarr[1] - 0)
 			if(starsec>=endsec){
 				cgi.show_error(note.beginLeEnd)
 				return
 			}
 			that.IspSceneCfg.ExtremeMode.ValidBeginMinute = starsec;
 			that.IspSceneCfg.ExtremeMode.ValidIntervalMinute = endsec - starsec;
 			var param = {
 				key:'IspSceneCfg',
 				data:JSON.stringify(that.IspSceneCfg)
 			}
			cgi.httpAjax('set.cgi', 'post', param, function(data) {
				if(data == 0) {
					cgi.show_error(note.msg_sussecd,true);
					refreshImageFast('canvasimg')
				} else {
					cgi.show_error(note.msg_error);
				}
			})
		},
		//图片参数里input值改变
		ex1Change: function() {
			var that = this;
			$("#ex1").slider("value", that.image_param.image_luminance);
		},
		ex2Change: function() {
			var that = this;
			$("#ext2").slider("value", that.image_param.image_contrast);
		},
		ex3Change: function() {
			var that = this;
			$("#ex3").slider("value", that.image_param.image_hue);
		},
		ex4Change: function() {
			var that = this;
			$("#ex4").slider("value", that.image_param.image_saturation);
		},
		
		//编码参数恢复默认
		defaultsEncoder:function(){
			var data = cgi.transfer("get.cgi?random=" + Math.random(), "get", {
				'key': 'defencoder_param'
			});
			this.encoder_param = data.defencoder_param;
			if(data.defencoder_param.encoder_maxstream){
				this.encoder_param.encoder_videoquality = '0';
			}else{
				this.encoder_param.encoder_maxstream = '512';
			}
		},
		//图像恢复默认
		defaultsImage:function(){
			var that = this;
			cgi.httpAjax('get.cgi?random=' + Math.random(), 'get', {
				'key': 'defimage_param'
			}, function(data) {
				that.image_param = data.defimage_param;
				//重绘
				setTimeout(function() {
					$("#ex1").slider("value", that.image_param.image_luminance);
					$("#ext2").slider("value", that.image_param.image_contrast);
					$("#ex3").slider("value", that.image_param.image_hue);
					$("#ex4").slider("value", that.image_param.image_saturation);
				}, 500)
			})
		},
		//曝光参数恢复默认
		defaultsExposure:function(){
			var data = cgi.transfer("get.cgi?random=" + Math.random(), "get", {
				'key': 'defexposure_param'
			});
			this.exposure_param = data.defexposure_param;
		},
		//osd参数恢复默认
		defaultsOSD:function(){
			var data = cgi.transfer("get.cgi?random=" + Math.random(), "get", {
				'key': 'defosd_param'
			});
			this.osd_param.osd_video_pos=data.defosd_param.osd_video_pos
			this.osd_param.osd_video_fontsize=data.defosd_param.osd_video_fontsize
			this.osd_param.osd_video_time=data.defosd_param.osd_video_time
			this.osd_param.osd_video_enable=data.defosd_param.osd_video_enable
			this.osd_param.osd_video_custominfo=data.defosd_param.osd_video_custominfo
			osd_video_custominfo_previse=data.defosd_param.osd_video_custominfo;
			$("[name='osd_video_custominfo']").val(data.defosd_param.osd_video_custominfo);
		},
		//曝光参数恢复默认
		defaultsIsp:function(){
			var data = cgi.transfer("get.cgi?random=" + Math.random(), "get", {
				'key': 'defIspSceneCfg'
			});
			if(JSON.stringify(data) != '{}'){
				this.IspSceneCfg = data.defIspSceneCfg;
				this.setTimes()
			}
		},
	},
	mounted: function() {
		this.initEncoder();
		var that =this;
		//延迟加载图像参数,优化体验
		setTimeout(function(){that.initImage()},500)
		//TODO 根据型号显示
   		if(version.indexOf('V83-CV102')!=-1 || version.indexOf('T83-CV102')!=-1||version=='T83-CV101'){
   			that.showMaxRatio=false;
   		}
   		
   		if(version.indexOf('ECT83-V3001C')!=-1||version.indexOf('ECV85')!=-1||version.indexOf('ECT85')!=-1||version.indexOf('EMF85')!=-1|| version.indexOf('DCL85')!=-1|| version.indexOf('DCS85')!=-1|| version.indexOf('DCL86')!=-1 ||version.indexOf('ECV86')!=-1|| version.indexOf('DCZ85')!=-1){
   			that.showencoder=false;
   			$('#pic4').remove();
   		}else{
   			$('#pic5').remove();
   		}
   		if(version.indexOf('ECV87')!=-1){
   			//that.showencoder=false;
   			that.showmjpeg=false;
   			that.show265=true;
				that.showIsp = true;
   		}
   		if(version.indexOf('DCL86')!=-1 ||version.indexOf('ECV86')!=-1|| version.indexOf('DCZ85')!=-1){
     		that.showencoder=true;
   			that.showmjpeg=false;
   			that.show265=true;
   			that.showIsp = true;
				if(version.indexOf('ECV86-V2001C-WJA')!=-1){
					that.show265=false;
				}
				if(version.indexOf('ECV86-V3011C')!=-1||version.indexOf('ECV86-V3021C')!=-1){
					that.showencoder=false;
				}
   		}
   		
   		if(version=='DMG88-V2011C' ||version=='DMG88-V2001C' || version=='DMF88-V2001C' || version=='DCE88-V3002C'||version.indexOf('DCE88-V3012C')!=-1||version.indexOf('DME88')!=-1||version.indexOf('DCF88')!=-1||version.indexOf('DCG88')!=-1||version.indexOf('ECF88')!=-1){
			that.disEncode=true;
	 	}
   		
   		if(version.indexOf('ECV85-V3201C')!=-1){
// 			that.showencoder=true;
// 			that.show265=true;
   			that.showIsp = true;
   		}
			if(version.indexOf('ECV85-V4001C')!=-1 ||version.indexOf('ECV86-V3011C')!=-1||version.indexOf('ECV86-V3021C')!=-1||version.indexOf('ECV85-V4011C')!=-1){
				that.showIsp = true;
			}
			if(version=='ECV87-V1011C-CHM'){
				that.showIsp = false;
			}
			if(version=='ECV87-V1001C-MO'|| version == 'ECV87-V1021C-MO'|| version=='ECV87-V2001C-TH' || version=='ECV87-V2001C-MO'|| version=='ECV87-V2001C-TW'|| version=='ECV87-V2001C-CHM'){
				that.showIsp = true;
			}
			
			var power = JSON.parse(cgi.getItem('power'))
			if (power.flip == 1) {
				that.showflip = true;
			}
	},
	computed:{
		disRatio:function(){
			if(version=='DMG88-V2011C' ||version=='DMG88-V2001C' || version=='DMF88-V2001C' || version=='DCE88-V3002C'||version.indexOf('DCE88-V3012C')!=-1||version.indexOf('DME88')!=-1||version.indexOf('DCF88')!=-1||version.indexOf('DCG88')!=-1||version.indexOf('ECF88')!=-1){
				//return true;
		 	}
			//return encoder_param.encoder_mode==0
		}
	}

})

function show_object() {
	var axvdc = document.getElementById("axvdc");
	if(axvdc == null || axvdc.object == null) {} else {
		axvdc.ip = window.location.host;
		axvdc.display = 1;
		axvdc.draw = 1;
	}
	$(".guideContent").css("display", "block")
}

var osd_video_custominfo_previse;// = $("[name='osd_video_custominfo']").val();
$(function() {
	setTimeout('show_object()', 400)
	$('#ex1').slider({
		"max": 100,
		"min": 0,
		"size": 5,
		"handle": "square",
		"value": $("[name='image_luminance']").val(),
		"slide": function(obj, ui) {
			vm.image_param.image_luminance = ui.value
		}
	});

	$('#ext2').slider({
		"max": 100,
		"min": 0,
		"size": 5,
		"handle": "square",
		"value": $("[name='image_contrast']").val(),
		"slide": function(obj, ui) {
			vm.image_param.image_contrast = ui.value
		}
	});
	$('#ex3').slider({
		"max": 100,
		"min": 0,
		"size": 5,
		"handle": "square",
		"value": $("[name='image_hue']").val(),
		"slide": function(obj, ui) {
			vm.image_param.image_hue = ui.value
		}
	});
	$('#ex4').slider({
		"max": 100,
		"min": 0,
		"size": 5,
		"handle": "square",
		"value": $("[name='image_saturation']").val(),
		"slide": function(obj, ui) {
			vm.image_param.image_saturation = ui.value
		}
	});
	
	$("[name='osd_video_custominfo']").keyup(function() {
		var str = $(this).val()
		var info = str.split("\n");
		var error = 0;
		if(info.length > 4) {
			error = 1;
			cgi.show_error(note.maxRow);
		}
		for(i = 0; i < info.length; i++) {
			if(info[i]) {
				if(info[i].gblen() > 30) {
					cgi.show_error(note.maxLine);
					error = 1
				}
			}
		}

		if(error == 1) {
			$("[name='osd_video_custominfo']").val(osd_video_custominfo_previse)
		}

		osd_video_custominfo_previse = $("[name='osd_video_custominfo']").val();
		//vm.osd_param.osd_video_custominfo = osd_video_custominfo_previse;

	})

})